<?php


 /**
 * URLマッピング用Filter
 * @package     NetCommons.filter
 * @author      Noriko Arai,Ryuji Masukawa
 * @copyright   2006-2007 NetCommons Project
 * @license     http://www.netcommons.org/license.txt  NetCommons License
 * @project     NetCommons Project, supported by National Institute of Informatics
 * @access      public
 */
class Filter_Restfulurl extends Filter {
	
    var $_container;

    var $_log;

    var $_filterChain;
    
    var $_actionChain;
    
    var $_request;
    
    var $_session;
     
    var $_className;
    
    var $_db;
    
    var $_errorList;
    
	/**
	 * コンストラクター
	 *
	 * @access	public	
	 */
	function Filter_Restfulurl() {
		parent::Filter();
	}

	/**
	 * URLマッピング用Filter
	 *
	 * @access	public
	 **/
	function execute() {
		$this->_container =& DIContainerFactory::getContainer();
        $this->_log =& LogFactory::getLog();
        $this->_filterChain =& $this->_container->getComponent("FilterChain");
        $this->_actionChain =& $this->_container->getComponent("ActionChain");
        $this->_request =& $this->_container->getComponent("Request");
        $this->_session =& $this->_container->getComponent("Session");
        $this->_db =& $this->_container->getComponent("DbObject");
        
        $this->_className = get_class($this);
        
        $this->_errorList =& $this->_actionChain->getCurErrorList();
    	
    	$this->_prefilter();
    	
        $this->_log->trace("{$this->_className}の前処理が実行されました", "{$this->_className}#execute");
        

        $this->_filterChain->execute();

        $this->_postfilter();
        $this->_log->trace("{$this->_className}の後処理が実行されました", "{$this->_className}#execute");
	}
	
	/**
     * プレフィルタ
     * 初期処理を行う
     * @access private
     */
    function _prefilter()
    {	
    	if ($this->_errorList->isExists()) {
    		//既にエラーがあればそのまま返却
    		return;	
    	}
    	if(DEFAULT_ACTION == 'install_view_main_init') {
    		return;
    	}
    	$_permalink_flag = $this->_session->getParameter("_permalink_flag");
    	if($_permalink_flag == _OFF) {
    		return;
    	}
    	
    	$name = $this->_request->getParameter("_restful_permalink");
    	$name = str_replace("%2F", "/", $name);
    	
    	$block_id = $this->_request->getParameter("block_id");
    	// $name = mb_convert_encoding(rawurldecode($name), 'UTF-8', 'auto');
    	if (isset($name) && $name != "") {
    		$name_strlen = strlen($name);
    		if(substr($name, 0, 1) == "/") {
				// 最初の「/」を除去
				$name = substr($name, 1, $name_strlen - 1);
				$name_strlen = strlen($name);
			}
			if(substr($name, $name_strlen-1, $name_strlen) == "/") {
				// 最後の「/」を除去
				$name = substr($name, 0, $name_strlen - 1);
				$name_strlen = strlen($name);
			}
			if(substr($name, $name_strlen - strlen(INDEX_FILE_NAME), $name_strlen) == INDEX_FILE_NAME) {
				// 最後の「/index.php」を除去
				$name = substr($name, 0, $name_strlen - strlen(INDEX_FILE_NAME));
			}
			$this->_request->setParameter("_restful_permalink", $name);
			if (isset($name) && $name != "" &&
				$name != _PERMALINK_PUBLIC_PREFIX_NAME &&
				$name != _PERMALINK_MYPORTAL_PREFIX_NAME &&
				$name != _PERMALINK_PRIVATE_PREFIX_NAME &&
				$name != _PERMALINK_GROUP_PREFIX_NAME) {
				$where_params = array('permalink' => $name);
				$pages = $this->_db->selectExecute("pages", $where_params, null, 1, 0);
				if ($pages !== false && isset($pages[0])) {
					$page_id = $this->_request->getParameter("page_id");
					if(!isset($page_id) || $page_id == "0") {
						$page_id = $pages[0]["page_id"];
					}
					$this->_request->setParameter("page_id", $page_id);
	    		} else {
					$commonMain =& $this->_container->getComponent("commonMain");
					// 現状、日本語固定
					$commonMain->redirectHeader("", 3, "存在しないページが指定されました。");
				}
			}
			if($name == _PERMALINK_PRIVATE_PREFIX_NAME) $this->_request->setParameter("page_id", -1);
    	}
    }
    
    /**
     * ポストフィルタ
     * @access private
     */
    function _postfilter()
    {
    }
}
?>
