<?php
/* vim: set expandtab tabstop=4 shiftwidth=4 softtabstop=4: */

/**
 * モジュールアップデートクラス
 *   質問内容、説明にアップロードされた画像、添付ファイルのガベージフラグをOFFにする
 * 
 * @package     NetCommons.components
 * @author      Noriko Arai,Ryuji Masukawa
 * @copyright   2006-2007 NetCommons Project
 * @license     http://www.netcommons.org/license.txt  NetCommons License
 * @project     NetCommons Project, supported by National Institute of Informatics
 * @access      public
 */
class Questionnaire_Update extends Action
{	
	//使用コンポーネントを受け取るため
	var $dbObject = null;
	
	function execute()
	{
		$sql = "SELECT COUNT(upload_id) "
				. "FROM {uploads} "
				. "WHERE garbage_flag = ? "
				. "AND file_path = ?";
		$input = array(
			_ON,
			'questionnaire/'
		);
		$counts = $this->dbObject->execute($sql, $input, 1, null, false);
		if (empty($counts[0][0])) {
			return true;
		}

		$sql = "UPDATE {uploads} SET "
					. "garbage_flag = ? "
				. "WHERE file_path = ?";
		$input = array(
			_OFF,
			'questionnaire/'
		);
		$result = $this->dbObject->execute($sql, $input);
		if ($result === false) {
			return false;
		}

		return true;
	}
}
?>