<?php
/**
 * モジュールアップデートアクションクラス
 * 　　登録者本人メール送信フラグカラムの追加
 * 
 * @package     NetCommons.components
 * @author      Noriko Arai,Ryuji Masukawa
 * @copyright   2006-2007 NetCommons Project
 * @license     http://www.netcommons.org/license.txt  NetCommons License
 * @project     NetCommons Project, supported by National Institute of Informatics
 * @access      public
 */
class Registration_Update extends Action
{	
	//使用コンポーネントを受け取るため
	var $dbObject = null;

	/**
	 * モジュールアップデートアクション
	 *
	 * @access  public
	 */
	function execute()
	{
		$adoConnection = $this->dbObject->getAdoDbObject();
		$metaColumns = $adoConnection->MetaColumns($this->dbObject->getPrefix() . 'registration');
		if (!isset($metaColumns['REGIST_USER_SEND'])) {
			$sql = "ALTER TABLE `" . $this->dbObject->getPrefix() . "registration` "
					. "ADD `regist_user_send` TINYINT(1) NOT NULL DEFAULT '0' AFTER `mail_send`;";
			if (!$this->dbObject->execute($sql)) {
				return false;
			}

			$sql = "SELECT registration_id, "
						. "mail_body "
					. "FROM {registration} "
					. "WHERE mail_body LIKE ?";
			$inputs = array(
				'%{X-URL}%'
			);
			$registrations = $this->dbObject->execute($sql, $inputs);
			if ($registrations === false) {
				return true;
			}

			foreach ($registrations as $registration) {
				$sql = "UPDATE {registration} SET "
						. "mail_body = ? "
						. "WHERE registration_id = ?";
				$inputs = array(
					str_replace('{X-URL}', '', $registration['mail_body']),
					$registration['registration_id']
				);
				$result = $this->dbObject->execute($sql, $inputs);
				if ($result === false) {
					return false;
				}
			}
		}

		return true;
	}
}
?>