<?php

/* vim: set expandtab tabstop=4 shiftwidth=4 softtabstop=4: */

/**
 * モジュールアップデートクラス
 * 
 * @package     NetCommons.components
 * @author      Noriko Arai,Ryuji Masukawa
 * @copyright   2006-2007 NetCommons Project
 * @license     http://www.netcommons.org/license.txt  NetCommons License
 * @project     NetCommons Project, supported by National Institute of Informatics
 * @access      public
 */
class System_Update extends Action
{	
	//使用コンポーネントを受け取るため
	var $db = null;
	
	function execute()
	{
		// 自動登録の入力キーを指定できるようにする
		$params = array("autoregist_use_input_key");
		$sql = "SELECT COUNT(*) FROM {config} WHERE conf_name = ?";
		$counts =$this->db->execute($sql, $params, null, null, false);
		if ($counts === false) {
			return false;
		}
		
		$count = intval($counts[0][0]);
		if ($count == 0) {
	        $params = array(
				"conf_modid" => _SYS_CONF_MODID,
				"conf_catid" => _ENTER_EXIT_CONF_CATID,
				"conf_name" => "autoregist_use_input_key",
				"conf_value" => _OFF
			);
			$result = $this->db->insertExecute("config", $params, true, "conf_id");
			if ($result === false) {
				return false;
			}

	        $params = array(
				"conf_modid" => _SYS_CONF_MODID,
				"conf_catid" => _ENTER_EXIT_CONF_CATID,
				"conf_name" => "autoregist_input_key",
				"conf_value" => "netcommons"
			);
			$result = $this->db->insertExecute("config", $params, true, "conf_id");
			if ($result === false) {
				return false;
			}
		}
		
		// 固定リンクを指定できるようにする
		$params = array("use_permalink");
		$sql = "SELECT COUNT(*) FROM {config} WHERE conf_name = ?";
		$counts =$this->db->execute($sql, $params, null, null, false);
		if ($counts === false) {
			return false;
		}
		
		$count = intval($counts[0][0]);
		if ($count == 0) {
	        $params = array(
				"conf_modid" => _SYS_CONF_MODID,
				"conf_catid" => _SERVER_CONF_CATID,
				"conf_name" => "use_permalink",
				"conf_value" => _OFF
			);
			$result = $this->db->insertExecute("config", $params, true, "conf_id");
			if ($result === false) {
				return false;
			}
		}
		return true;
	}
}
?>
